## -*- coding: utf-8 -*-
## Copyright (C)2006 Ingeniweb

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING. If not, write to the
## Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

# CMF imports
from Products.CMFCore.utils import getToolByName
from Products.PloneiCalendar.content.iCalendar import iCalendar

from copy import copy
from Persistence import PersistentMapping
from Acquisition import aq_base

def migrateToArchetypes(self, REQUEST=None):
    print """
    -------------------------------------------------
        Execute migration from old CMF PloneiCalendar
        to the new archetypes one
    """
    nb_updated = 0
    pcatalog = getToolByName(self, 'portal_catalog')
    brains = pcatalog.searchResults(meta_type='iCalendar')
    for brain in brains:
        obj = brain.getObject()
        if hasattr(obj, 'data'):
            print "updating", obj.title_or_id
            updateObject(obj, 'iCalendar')
            nb_updated = nb_updated + 1
    
    if REQUEST is not None:
        return REQUEST.RESPONSE.redirect(
            self.absolute_url() + \
            '/manage_migration?manage_tabs_message=%s+iCalendar+updated' % nb_updated,
        )
            

def updateObject(old_one, new_type):
    creation_date = old_one.creation_date
    modification_date = old_one.modification_date        
    parent = old_one.getParentNode()
    obj_id = old_one.id
    parent.manage_delObjects(obj_id)
    parent.invokeFactory('iCalendar', obj_id)
    
    new_one = getattr(parent, obj_id)        
    new_one.setTitle(old_one.title)
    new_one.creation_date = creation_date
    new_one.modification_date = modification_date
    new_one.setContentType(old_one.content_type)
    new_one.setSubject(old_one.subject)
    new_one.setContributors(old_one.contributors)
    new_one.setEffectiveDate(old_one.effective_date)
    new_one.setExpirationDate(old_one.expiration_date)
    new_one.setLanguage(old_one.language)
    
    if hasattr(aq_base(old_one), 'getWrappedOwner'):
        new_one.changeOwnership(old_one.getWrappedOwner())
    else:
        new_one.changeOwnership(old_one.getOwner(info = 1))    
    if hasattr(aq_base(old_one), 'isDiscussable'):
        new_one.allowDiscussion(old_one.isDiscussable())
    if hasattr(old_one, 'uid'):
        new_one.uid = old_one.uid
    wfh = getattr(old_one, 'workflow_history', None)
    if wfh:
        wfh = copyPermMap(wfh)
        new_one.workflow_history = wfh
    
    new_one.getField('webcolor').set(new_one, old_one.webcolor)    
    new_one.getField('file').set(new_one, old_one.data)
    print "object: %s migrated." % obj_id
    
def copyPermMap(old):
    """bullet proof copy
    """
    new = PersistentMapping()
    for k,v in old.items():
        nk = copy(k)
        nv = copy(v)
        new[k] = v
    return new
