# -*- coding: utf-8 -*-
## PloneiCalendar
## Store, share, and browse your iCalendar files in Plone
## Copyright (C)2006 Ingeniweb

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING. If not, write to the
## Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


# Python imports
import datetime
import sys

# Zope imports
import AccessControl.Permissions

# CMF imports
from Products.CMFCore.DirectoryView import registerDirectory
from Products.CMFCore import utils, CMFCorePermissions

# Archetypes imports
from Products.Archetypes.public import listTypes, process_types

# Products imports
from Products.PloneiCalendar import PloneiCalendarTool
from Products.PloneiCalendar import ColorWidget
from Products.PloneiCalendar.content import iCalendar
from Products.PloneiCalendar.config import *
    
# Provides backward module compatibilty to allow migration
sys.modules['Products.PloneiCalendar.PloneiCalendar'] = iCalendar

# Register skin
registerDirectory(SKINS_DIR, GLOBALS)

from zLOG import LOG, DEBUG, INFO

# Initialization method
def initialize(context):
    # Initialize tool
    utils.ToolInit(PROJECTNAME + ' Tool', 
                   tools=( PloneiCalendarTool.PloneiCalendarTool, ), 
                   product_name='PloneiCalendar', 
                   icon='tool.gif',  
                   ).initialize(context) 
    
    # Initialize content
    types_list = listTypes(PROJECTNAME)
    contentClasses, contentConstructors, ftis = process_types(types_list, PROJECTNAME)        
    utils.ContentInit(
        PROJECTNAME + ' Content',
        content_types = contentClasses,
        permission = PloneiCalendar_addPermission,
        extra_constructors = contentConstructors,
        fti = ftis,
        ).initialize(context)
