## -*- coding: utf-8 -*-
## Copyright (C)2006 Ingeniweb

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING. If not, write to the
## Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

# Archetypes imports
try:
    from Products.LinguaPlone.public import *
except ImportError:
    # No multilingual support
    from Products.Archetypes.public import *
    
from Products.PloneiCalendar.config import I18N_DOMAIN
from Products.PloneiCalendar.ColorWidget import ColorWidget

iCalendarSchema = BaseSchema.copy() + Schema((
    StringField(
        'webcolor',
        required=True,
        searchable=0,
        default='#FFFFFF',
        widget=ColorWidget(
            label='Color',
            label_msgid='Color',
            description="Choose the color of events in this calendar.",
            description_msgid='help_color',
        ),
    ),
    FileField(
        'file',
        required=True,
        primary=True,
        default_content_type='text/calendar',
        widget=FileWidget(
            label='File',
            label_msgid='File',
            description="Select the file to be added by clicking the 'Browse' button.",
            description_msgid='help_file',
            show_content_type=True,
        ),
    ),
))
iCalendarSchema['description'].isMetadata
iCalendarSchema['description'].schemata = 'default'
